
        INCLUDE \masm32\include\masm32rt.inc

;------------------------------------------------------------------------------------------

GetBitmapSize PROTO   :HBITMAP,:LPVOID

;------------------------------------------------------------------------------------------

MAXSIZE        EQU 260

IDM_FILE_OPEN  EQU 1
IDM_FILE_EXIT  EQU 2

;------------------------------------------------------------------------------------------

        .DATA

ClassName    db "BmpView",0
AppName      db "Viewer",0
MenuName     db "FirstMenu",0

FilterString db "bmp files",0,"*.bmp",0,0
buffer       db MAXSIZE dup(0)
OurTitle     db "Open BMP file",0

;------------------------------------------------

        .DATA?

hInstance    HINSTANCE ?
CommandLine  LPSTR ?
hWin         HWND ?
hbmpBitmap   HBITMAP ?
bmSize       _SIZE <>
ofn          OPENFILENAME <>

;------------------------------------------------------------------------------------------

        .CODE

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        LOCAL   hdcMem       :HDC
        LOCAL   hbmpPrev     :HBITMAP
        LOCAL   ps           :PAINTSTRUCT

    .if uMsg==WM_PAINT
        INVOKE  BeginPaint,hWnd,addr ps
        .if hbmpBitmap
            INVOKE  CreateCompatibleDC,eax
            mov     hdcMem,eax
            INVOKE  SelectObject,eax,hbmpBitmap
            mov     hbmpPrev,eax
            mov     ecx,ps.rcPaint.right
            mov     edx,ps.rcPaint.bottom
            mov     eax,bmSize.x
            .if eax<ecx
                xchg    eax,ecx
            .endif
            mov     eax,bmSize.y
            .if eax<edx
                xchg    eax,edx
            .endif
            sub     ecx,ps.rcPaint.left
            sub     edx,ps.rcPaint.top
            INVOKE  BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ecx,edx,
                    hdcMem,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
            INVOKE  SelectObject,hdcMem,hbmpPrev
            INVOKE  DeleteDC,hdcMem

        .else
            mov     ecx,ps.rcPaint.right
            mov     edx,ps.rcPaint.bottom
            sub     ecx,ps.rcPaint.left
            sub     edx,ps.rcPaint.top
            INVOKE  PatBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ecx,edx,WHITENESS

        .endif

        INVOKE  EndPaint,hWnd,addr ps

    .elseif uMsg==WM_CREATE
        push    hWnd
        pop     hWin

    .elseif uMsg==WM_DESTROY
        call    DeleteOldBitmap
        INVOKE  PostQuitMessage,NULL

    .elseif uMsg==WM_COMMAND
        mov     eax,wParam
        .if eax==IDM_FILE_OPEN
            mov     ofn.lStructSize,SIZEOF ofn
            push    hWnd
            pop     ofn.hWndOwner
            push    hInstance
            pop     ofn.hInstance
            mov     ofn.lpstrFilter,OFFSET FilterString
            mov     ofn.lpstrFile,OFFSET buffer
            mov     ofn.nMaxFile,MAXSIZE
            mov     ofn.Flags,OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
            mov     ofn.lpstrTitle,OFFSET OurTitle
            INVOKE  GetOpenFileName,ADDR ofn
            .if eax==TRUE
                INVOKE  LoadImage,0,ofn.lpstrFile,IMAGE_BITMAP,0,0,LR_LOADFROMFILE
                .if eax
                    push    eax
                    call    DeleteOldBitmap
                    INVOKE  InvalidateRect,hWnd,NULL,NULL
                    INVOKE  UpdateWindow,hWnd
                    pop     eax
                    mov     hbmpBitmap,eax
                    INVOKE  GetBitmapSize,eax,offset bmSize
                    INVOKE  InvalidateRect,hWnd,NULL,NULL
                    INVOKE  UpdateWindow,hWnd

                .endif

            .endif

        .elseif eax==IDM_FILE_EXIT
            INVOKE  DestroyWindow,hWnd

        .endif

    .else
        INVOKE  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif

    xor    eax,eax
    ret

WndProc endp

;------------------------------------------------------------------------------------------

DeleteOldBitmap proc

    mov     eax,hbmpBitmap
    .if eax
        INVOKE  DeleteObject,eax
        mov     hbmpBitmap,0
    .endif

    ret

DeleteOldBitmap endp

;------------------------------------------------------------------------------------------

GetBitmapSize PROC hbmpBmp:HBITMAP,lpSize:LPVOID

        LOCAL   bms :BITMAP

        xor     eax,eax
        mov     bms.bmType,eax
        mov     bms.bmWidth,eax
        mov     bms.bmHeight,eax
        INVOKE  GetObject,hbmpBmp,sizeof BITMAP,addr bms
        mov     ecx,bms.bmWidth
        mov     eax,bms.bmHeight
        mov     edx,lpSize
        .if edx
            mov     [edx]._SIZE.x,ecx
            mov     [edx]._SIZE.y,eax
        .endif
        ret

GetBitmapSize ENDP

;------------------------------------------------------------------------------------------

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

        LOCAL   wc   :WNDCLASSEX
        LOCAL   msg  :MSG
        LOCAL   hwnd :HWND

        mov     wc.cbSize,SIZEOF WNDCLASSEX
        mov     wc.style, CS_HREDRAW or CS_VREDRAW
        mov     wc.lpfnWndProc, OFFSET WndProc
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        push    hInst
        pop     wc.hInstance
        mov     wc.hbrBackground,COLOR_WINDOW+1
        mov     wc.lpszMenuName,OFFSET MenuName
        mov     wc.lpszClassName,OFFSET ClassName
        INVOKE  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        INVOKE  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        INVOKE  RegisterClassEx, addr wc
        INVOKE  CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,
                WS_OVERLAPPEDWINDOW,
                CW_USEDEFAULT,CW_USEDEFAULT,479,359,NULL,NULL,hInst,NULL
        mov     hwnd,eax
        INVOKE  ShowWindow,hwnd,SW_SHOWNORMAL
        INVOKE  UpdateWindow,hwnd

    .while TRUE
        INVOKE  GetMessage,ADDR msg,NULL,0,0
    .break .if (!eax)
        INVOKE  TranslateMessage,ADDR msg
        INVOKE  DispatchMessage,ADDR msg
    .endw

        mov     eax,msg.wParam
        ret

WinMain endp

;------------------------------------------------------------------------------------------

start:  INVOKE  GetModuleHandle,NULL
        mov     hInstance,eax
        INVOKE  GetCommandLine
        mov     CommandLine,eax
        INVOKE  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
        INVOKE  ExitProcess,eax

;------------------------------------------------------------------------------------------

        END     start

